<?php
namespace SOSIDEE_HSC\SRC;
defined( 'SOSIDEE_HSC' ) or die( 'you were not supposed to be here' );
use \Elementor as NativeElementor;

class Widget extends \SOSIDEE_HSC\SOS\WP\Elementor\Widget
{
    protected $ctrlMode;
    protected $ctrlContent;

    public static $SOS_TAG = 'problem';

    public function setKey() {
        $this->key = \SOSIDEE_HSC\SosPlugin::instance()->key . '_ew' ;
    }

    public function initialize() {
        parent::initialize();

        $plugin = self::plugin();

        $this->title = $plugin::t_('elementor.widget.title');

        $this->section->title = $this->title;
        $this->icon = 'eicon-preview-medium';

        $this->ctrlMode = $this->addControl($plugin::t_('elementor.widget.mode.label') . ':', NativeElementor\Controls_Manager::SELECT );
        $this->ctrlMode->options = [
            '' => $plugin::t_('elementor.widget.mode.select'),
            'hide-guest' => $plugin::t_('elementor.widget.mode.hide.guest'),
            'hide-logged' => $plugin::t_('elementor.widget.mode.hide.logged'),
            'show-guest' => $plugin::t_('elementor.widget.mode.show.guest'),
            'show-logged' => $plugin::t_('elementor.widget.mode.show.logged'),
        ];
        $this->ctrlMode->default = '';

        $this->ctrlContent = $this->addControl($plugin::t_('elementor.widget.content.label') . ':', NativeElementor\Controls_Manager::WYSIWYG );
        $this->ctrlContent->description = $plugin::t_('elementor.widget.content.description');
        $this->ctrlContent->default = $plugin::t_('elementor.widget.content.placeholder');

    }

    protected function render() {
        parent::render();

        $this->add_inline_editing_attributes( $this->ctrlContent->key, 'advanced' );
        $settings = $this->get_settings_for_display();
        if ( key_exists($this->ctrlMode->key, $settings) ) {
            $value = $settings[ $this->ctrlMode->key ];
        } else {
            $value = '?-?';
        }
        $items = explode('-', $value);
        $ras = $this->get_render_attribute_string( $this->ctrlContent->key );
        if ( key_exists($this->ctrlContent->key, $settings) ) {
            $content = $settings[ $this->ctrlContent->key ];
        } else {
            $plugin = self::plugin();
            $content = '<strong style="color:red;">' . $plugin::t_('elementor.widget.mode.invalid') . '</strong>';
        }
        $html = '[' . self::$SOS_TAG . ' ' . $items[0] . '="' . $items[1] . '"]<hscontent ' . $ras . '>' . $content . '</hscontent>[/' . self::$SOS_TAG . ']';
        echo $html;
    }

}